require 'Debugger'

include Fox
include Mondrian::Managers

module Mondrian

  class EvalFrame < Dockable
		attr_accessor :slave
		
		def initialize(parent)	
			super(parent)
			self.title = "Eval"
			split = FXVerticalFrame.new(self, LAYOUT_FILL_X | LAYOUT_FILL_Y)
			frame = FXHorizontalFrame.new(split, LAYOUT_FILL_X)			
			@input = FXTextField.new(frame, 25, self, 0, TEXTFIELD_ENTER_ONLY | LAYOUT_FILL_X)
			@input.connect(SEL_COMMAND, method(:on_input))
			@button = FXButton.new(frame, "Eval")
			@button.connect(SEL_COMMAND, method(:on_input))
			@value = FXText.new(split, nil, 0, TEXT_FIXEDWRAP | TEXT_WORDWRAP | LAYOUT_FILL_X | LAYOUT_FILL_Y | TEXT_AUTOSCROLL | TEXT_READONLY)
			@slave = nil			
			
			@input.connect(SEL_COMMAND, method(:on_input))
			Debugger.instance.subscribe_all(self, method(:debugger_update))
		end
			
		def on_input(sender, message, data)
			@value.appendText(@input.text + "\n==> ")
			appender = Proc.new do |result| 
				@value.appendText("#{result}")
				@value.appendText("\n\n")
				@value.setCursorRow(@value.numRows-1)
				@value.setBottomLine(@value.cursorPos)
				@input.selectAll
			end
			
			if Debugger.instance.stopped?								
				Debugger.instance.eval(@input.text, &appender)
			elsif not Debugger.instance.connected?
				appender.call("ERROR: Debugger is not connected")
			else
				appender.call("ERROR: Debugger is not stopped")
			end
		end
		
		def debugger_update(sender, message, data)
		end
	end
	
end