require 'fox16'
require 'FileManager'

include Fox

module Mondrian
	class FileBrowser < Dockable
		def initialize(parent)
			super(parent)

			frame = FXHorizontalFrame.new(self, LAYOUT_FILL_X | LAYOUT_FILL_Y | FRAME_THICK, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)

			@fileTree = FileTree.new(frame)
      @fileTree.connect(SEL_DOUBLECLICKED, method(:onDoubleClicked))

			self.title = "File Browser"
		end

    def slave=(slave)
      @slave = slave
    end

    def onDoubleClicked(sender, message, item)
      if @slave and @fileTree.itemFile? item
        file = FileManager.instance.open_file @fileTree.itemPathname(item)
        if file.kind_of?(ProjectFile)
          SessionManager.instance.open_project(file)
        else
          @slave.launch_viewer(nil, file)
        end
      end
    end

	end

	class FileTree < FXDirList
		def initialize(parent)
			super(parent, nil, 0, ( DIRLIST_SHOWFILES |
															TREELIST_BROWSESELECT |
															TREELIST_SHOWS_LINES |
															TREELIST_SHOWS_BOXES |
															TREELIST_ROOT_BOXES |
															LAYOUT_FILL_X |
															LAYOUT_FILL_Y), 0, 0, 0, 0)
		end
	end
end
