require 'fox16'

require 'SessionManager'
require 'IconManager'
require 'framework/file'
require 'FileManager'
require 'framework/protogui/workspacebrowser'
require 'framework/project'
require 'plugins/mondrian.fox16_0.0.1/fxicon'

include Fox

module Mondrian
	class FXWorkspaceBrowser < Dockable
		def initialize(parent)
			super(parent)

			frame = FXHorizontalFrame.new(self, LAYOUT_FILL_X | LAYOUT_FILL_Y | FRAME_THICK, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)

			self.title = "Workspace Browser"

            SessionManager.instance.subscribe_all(self, method(:update))
		end
		
		
		def add_tree(node, fxnode = nil)
		    node.each_child { |child|
    	        icon = Kinshasa::Icon.fox16.resource_for(child.data)
    	        add_tree(child, @tree.appendItem(fxnode, child.data.name, icon, icon))
    		}
		end
		
		
		def add_project_entries(project, node, spath = nil)
		     spath = project.path unless spath
		     
			 project.folders(spath).each { |path|
 			     icon = Icon.fox16.resource_for(path)
			     last = @tree.appendItem(node, File.basename(path), icon, icon)
			     add_project_entries(project, last, path)
			 }
			 project.files(spath).each { |path|
 			     icon = Icon.fox16.resource_for(path)
			     @tree.appendItem(node, File.basename(path), icon, icon, FileTypeResource.resource_for(path).new(path))
			 }
		end
		
		
        def slave=(slave)
            @slave = slave
        end
        
        
        def update(sender, message, data)
            
        end
	end
end
