# plugin.rb
#
# Contributors:: Oliver Smith

require 'singleton'


module Kinshasa

    # A class for storing the list of currently loaded plugins.

    def PluginRegistry
        include Singleton
    
        def initialize
            @plugins = []
        end
    
    
        def register_plugin(plugin)
            @plugins << plugin
        end
    end



    # A class for representing and registering plugins.  Simply subclass this
    # to register a new Mondrian plugin.

    class Plugin
        def Plugin.inherited(klass)
            PluginRegistry.instance.register_plugin klass.new
        end
    end
    
end