# texteditor.rb
#
# Contributors:: Oliver Smith


require 'framework/mixins/editable'


module Kinshasa

    # A proto-GUI class for editing a +TokenString+.

    class TextEditor
        include Editable
        
        event :text_inserted, :text_deleted, :text_lexed
        
        attr_reader :tokenstring
        
        def initialize(tokenstring)
            @tokenstring = tokenstring
            
            @tokenstring.subscribe_text_lexed(self) { |sender, event, range| notify_text_lexed range }
        end
        
        
        # Allows us to treat this class like a +TokenString+.
    
        def method_missing(method_symbol, *args, &block)
            @tokenstring.send(method_symbol, *args, &block) 
        end

    end
    
end