# workspacebrowser.rb
#
# Contributors:: Oliver Smith


require 'framework/mixins/notifier'
require 'framework/workspace'


module Kinshasa

    # A proto-GUI class for using a +Workspace+.

    class WorkspaceBrowser
        include Notifier
        
        attr_reader :workspace
        
        def initialize(workspace_or_path)
            if workspace.kind_of? Workspace
                @workspace = workspace_or_path
            else
                @workspace = Workspace.new(workspace_or_path)
            end
        end
            
        
        # Allows us to treat this class like a +Workspace+.
    
        def method_missing(method_symbol, *args, &block)
            @workspace.send(method_symbol, *args, &block) 
        end

    end
    
end